/*
 *  tty_at.c -- RS-232Co (IBM PC/AT݊@p)
 *
 *  revision history:
 *	0.0: Dec. 31, 1996 by Dai ISHIJIMA (for LXFS4D)
 *	0.1: Jan.  1, 1997
 *	0.2: Apr.  7, 1997
 *	0.3: May. 29, 1997
 *	0.4: Dec.  4, 1998 (for Paldio Phone Book)
 *	0.5: Dec. 23, 1998
 *	0.6: Feb. 10, 1999 (for LSI C-86 Ver.3.30c H)
 *	0.7: Mar.  1, 1999
 *	0.8: Aug. 14, 1999 (t[ -DRTSCTS)
 *	0.9: Aug. 20, 1999
 *	1.0: Aug. 31, 1999 (FIFO/16550A Ή)
 *
 *  Ql:
 *	E :u荞ݐvO~Ov,
 *	  gWX^ZpXyV No.43 (CQoŎ, 1994), pp.112-124.
 *      E Ms:uVAE|[g̃vO~Ov,
 *	  BootStrap Project-2 No.4 (CQoŎ, 1993), pp.115-133.
 *	Eēc : C܂܂PC/ATvO~O (\tgoN, 1993).
 *	ER{ aM,  , k Í, {{ PO, { Dv:
 *	  PC-9801ʐMvgRX[p[eNjbN (AXL[, 1993), pp.60-65.
 *	Ex F:uPC̃VAE|[gƃpE|[gv,
 *	  gWX^Zp 1999N9 <36 9> (CQoŎ, 1999),
 *	  pp.241-246.
 *	  (Җ́uxv͖{́u\vu\\vu؁vd˂悤Ȏł)
 *        (JIS X 0212-1990  3541_̕)
 */

#include <stdio.h>
#include <dos.h>

#include <time.h>
time_t tictac();


#ifdef LSIC
#define interrupt
#include <stdlib.h>
#include <machine.h>
#ifdef USE_INTR
#include "intr.h"
#define disable() di()
#define enable()  ei()
#define getvect _dos_getvect
#define setvect _dos_setvect
#endif
#endif

#define YES 1
#define NO  0


#ifndef PORT_MACRO
#ifdef inportb
#undef inportb
#endif
#ifdef outportb
#undef outportb
#endif
#endif


#ifdef USE_INTR
#define intrttygetc ttygetc
#else
#define rawttygetc ttygetc
#endif


#define SIO_TIMEOUT 5

/*
 *  i8250  I/O|[g
 */
/* I/O|[gAhX */
#define mdmctrl(b) ((b) + 4) 	/* fRg[WX^ */
#define mdmstat(b) ((b) + 6) 	/* fXe[^XWX^ */
#define rxdata(b)  ((b) + 0)	/* Mf[^ */
#define txdata(b)  ((b) + 0)	/* Mf[^ */
#define enintr(b)  ((b) + 1)	/* 荞݋ */
#define linstat(b) ((b) + 5)	/* CXe[^X */
#define linctrl(b) ((b) + 3)	/* CRg[ */
#define divlo(b)   ((b) + 0)	/* 䉺ʃoCg */
#define divhi(b)   ((b) + 1)	/* ʃoCg */
#define fifo(b)	   ((b) + 2)	/* FIFO䃌WX^ */

/* CRg[WX^ */
#define CS6    0x01	/* LN^ 6rbg */
#define CS7    0x02	/* 7rbg */
#define CS8    0x03	/* 8rbg */
#define LSTOP  0x04	/* Xgbvrbg */
#define PE     0x10	/* peB */
#define EVENP  0x20	/* peB */
#define STICKP 0x40	/* XeBbNpeB */
#define SETDIV 0x80	/* ݒ */
/* 8f[^rbg, 1Xgbvrbg */
#define N81    (CS8)

/* 荞݋WX^ */
#define RXRE 0x01	/* M荞݋ */
#define TXRE 0x02	/* M荞݋ */
#define LSCE 0x04	/* CXe[^Xω荞݋ */
#define MSCE 0x08	/* fXe[^Xω荞݋ */

/* fRg[WX^ */
#define DTR  0x01	/* DTRM */
#define RTS  0x02	/* RTSM */
#define MPOW 0x04	/* OUT1: f̓d? */
#define INTE 0x08	/* OUT2: 荞݋ */
#define LOOP 0x10	/* [vobN */

/* CXe[^XWX^ */
#define RXRDY 0x01	/* MfB */
#define OERR  0x02	/* I[o[G[ */
#define PERR  0x04	/* peBG[ */
#define FERR  0x08	/* t[~OG[ */
#define BRKI  0x10	/* u[NC^vg */
#define TXRDY 0x20	/* Mf[^WX^ */
#define TXEMP 0x40	/* MVtgWX^ */
#define ANYERR (OERR | PERR | FERR)

/* fXe[^XWX^ */
#define CTS 0x10	/* CTSM */
#define DSR 0x20	/* DSRM */
#define RI  0x40	/* RIM */
#define DCD 0x80	/* DCDM */

/* FIFO䃌WX^ */
#define FIFO14   0xc0	/* FIFOgKx: 14oCg */
#define FIFO08   0x80	/* FIFOgKx:  8oCg */
#define FIFO04   0x40	/* FIFOgKx:  4oCg */
#define FIFO00   0x00	/* FIFOgKx:  1oCg */
#define SENDRST  0x04	/* MFIFOZbg */
#define RECVRST  0x02	/* MFIFOZbg */
#define FIFOENBL 0x01	/* FIFOL */

/* 荞ݗvWX^ (= FIFO䃌WX^) */
#define IRPEND  0x01
#define IRID0   0x02
#define IRID1   0x04
#define IRID2   0x08
/* 荞ݎ */
#define IR_ANY  0x01	/* Ȃ? */
#define IR_LSR  0x06	/* MCXe[^X */
#define IR_RECV 0x04	/* f[^M */
#define IR_CTO  0x0c	/* LN^E^CEAEg */
#define IR_TEMP 0x02	/* MWX^ */
#define IR_MSR  0x00	/* fXe[^X */
/* */
#define OKFIFO1 0x40	/* FIFOL */
#define OKFIFO2 0x80	/*  */



#define TICKS_AT 115200L


/*
 * 荞݃Rg[ i8259A  I/O|[g
 */
/* I/O|[gAhX */
#define PICIMR  0x21	/* }X^荞݃Rg[̃}XNEWX^ */
#define PICOCW2 0x20	/* R}h[h (EOI) */

/* 荞݃}XN */
#define IE_TMR  0xfe	/* ^C}荞ݗL */
#define IE_KBD  0xfd	/* L[{[h荞ݗL */
#define IE_CRT  0xfb	/* CRT荞ݗL */
#define IE_INT0 0xfd	/* goXINT0荞ݗL */
#define IE_SIO  0xef	/* RS232C荞ݗL */
#define ie_sio(port)  ((port & 1) ? 0xf7 : 0xef)
/* ȉ :-) */

/* R}h[h2 */
#define PICEOI  0x20	/* 荞ݏI */


/* ZOg, ItZbg far |C^ */
#define farptr(seg,ofs) \
	((void far *)((((long)((unsigned)(seg)))<<16)+((unsigned)(ofs))))

/* ǂ݂ (݂ɂg邯... ^^) */
#define mw(seg,ofs) (*(unsigned int  far *)(farptr((seg),(ofs))))

/* BIOS [NGÃZOgAhX */
#define BIOSWORK 0x0040

/* VA|[g̃x[XAhX */
#define portadr(portno) (mw(BIOSWORK, (portno) * 2))
#define ESCAPE 27


/*
 * M荞ݗp
 */
#ifdef USE_INTR
/* #define SIO_INTR 0x0c */	/* RS232CM荞݃xN^ */
#define sio_intr(port) (0x0c - (port & 1))
#ifdef LSIC
void (far *save_vec)();
#else
void interrupt far (*save_vec)();	/* 荞݃xN^̕ۑ */
#endif
int  save_mask;				/* 荞݃}XN̕ۑ */
int  intr_port;				/* 荞ݎMɎgp|[g */

/*#define RINGSIZ 2048 			/* 2ׂ̂悪(?) */
#define RINGSIZ 4096 			/* 2ׂ̂悪(?) */
#define ringpos(top,siz) (((top) + (siz)) & (RINGSIZ - 1))
static unsigned char ringbuf[RINGSIZ];	/* Mobt@ */
static int ringtop;
static int ringsiz;
static int ovfsilo;	/* obt@EI[o[t[EtO */
#endif

static int sioerr;	/* 8250̃G[ */

#define FLOW_STOP 0
#define FLOW_START 1


/* |[g̔ԍ (ttyd0, com1 -> 0, ttyd1,com2 -> 1) Ԃ */
int opentty(char *tty)
{
    int port;

    if (('0' <= *tty) && (*tty <= '3')) { /* '0', '1',... */
	port = *tty & 0x03;
    }
    else if ((*tty == 'c') || (*tty == 'C')) { /* com?: */
	port = (tty[3] - 1) & 0x03;
    }
    else if (*tty == 't') {
	port = tty[4] & 0x03;
    }
    else {
	fprintf(stderr, "can't open tty (%s)\n", tty);
	exit(1);
    }
#ifdef USE_INTR
    intr_port = port;
#endif
    return(port);
}


/* ʐM̐ݒ */
void init8250(int port, long bps)
{
    int c;

    /* ݒ */
    c = TICKS_AT / bps;
    disable();
    outp(linctrl(portadr(port)), SETDIV);
    outp(divlo(portadr(port)), c & 0x00ff);
    outp(divhi(portadr(port)), c >> 8);
    /* rbgȂǂ̐ݒ */
    outp(linctrl(portadr(port)), N81);
#ifdef FIFO
    outp(fifo(portadr(port)), FIFO04 | SENDRST | RECVRST | FIFOENBL);
    if (inp(fifo(portadr(port))) & OKFIFO1) {
/*	fprintf(stderr, "type: 16550A, fifo enabled\n");*/
    }
#endif    
#ifdef USE_INTR
    /* M荞݂ */
    outp(enintr(portadr(port)), RXRE);
#else
    outp(enintr(portadr(port)), 0);
#endif
    outp(mdmctrl(portadr(port)), RTS | DTR | INTE);
    enable();
}


/* t[ */
void flowctl(int start_stop)
{
    if (start_stop) {
	outp(mdmctrl(portadr(intr_port)), RTS | DTR | INTE);
    }
    else {
	outp(mdmctrl(portadr(intr_port)), DTR | INTE);
    }	
}

/* M */
/* 2000/07/14 T.Sagae oCif[^ unsigned t */
int ttyputc(int port, unsigned char ch)
{
    time_t t;
    int status;

    t = tictac();
#ifdef RTSCTS    /* */
    while (((status = inp(mdmstat(portadr(port)))) & CTS) == 0) {
	if (tictac() - t > SIO_TIMEOUT) {
	    fprintf(stderr, "ttyputc(): timeout, ");
	    fprintf(stderr, "modem status (i8250) = %02x\n", status);
	    return(EOF);
	}
    }
#endif    /* */
    while (((status = inp(linstat(portadr(port)))) & TXRDY) == 0) {
	if (tictac() - t > SIO_TIMEOUT) {
	    fprintf(stderr, "ttyputc(): timeout, ");
	    fprintf(stderr, "line status (i8250) = %02x\n", status);
	    return(EOF);
	}
    }
    outp(txdata(portadr(port)), ch);
    return(ch);
}


/* M */
int rawttygetc(int port)
{
/*#ifndef USE_INTR*/
    int status;
/*#endif*/
#ifdef TTY_ESC_CHK
    int ch;
#endif

#ifdef TTY_ESC_CHK
    if (kbhit()) {
	ch = getch();
	if (ch == ESCAPE) {
	    ttyrestore(port);
	    exit(3);
	}
    }
#endif
/* #ifndef USE_INTR */
    status = inp(linstat(portadr(port)));
    sioerr |= status & ANYERR;
    if (sioerr & PERR) {
	fprintf(stderr, "parity error\n");
    }
    else if (sioerr & OERR) {
	fprintf(stderr, "overrun error\n");
    }
    else if (sioerr & FERR) {
	fprintf(stderr, "framing error\n");
    }
    sioerr = 0;
    if ((status & RXRDY) == 0) {
	return(EOF);
    }
/* #endif */	/* 荞ݎM̓Xe[^X`FbNȂł悢? */
    return((unsigned char)inp(rxdata(portadr(port))));
}


#ifdef USE_INTR
/* M荞ݏ */
void interrupt far recv_intr(void)
{
    int ch;

#ifndef LSIC
    disable();
#endif
    while ((ch = rawttygetc(intr_port)) != EOF) {
	ringbuf[ringpos(ringtop, ringsiz)] = ch;
	++ringsiz;
#ifdef RTSCTS	/* */
	if (ringsiz >= RINGSIZ / 2) {
	    flowctl(FLOW_STOP);
	}
#endif	/* */
	if (ringsiz >= RINGSIZ) {
	    ovfsilo = YES;
	    ringsiz = 0;
	}
    }
    outp(PICOCW2, PICEOI);
#ifndef LSIC
    enable();
#endif
}


/* M荞݂\ɂ */
void set_intr(int port)
{
    disable();
    save_vec = getvect(sio_intr(port));
#ifdef LSIC
    init_intr(recv_intr);
    setvect(sio_intr(port), intr_wrapper);
#else
    setvect(sio_intr(port), recv_intr);
#endif
    save_mask = inp(PICIMR);
    outp(PICIMR, save_mask & ie_sio(port));
    enable();
    ringtop = 0;
    ringsiz = 0;
    sioerr = 0;
    ovfsilo = NO;
}


/* Oobt@ǂ݂ */
int intrttygetc(int fd)
{
    int ch;

    if (ovfsilo == YES) {
	fprintf(stderr, "silo buffer overflow\n");
	ovfsilo = NO;
    }
    if (sioerr & PERR) {
	fprintf(stderr, "parity error\n");
    }
    else if (sioerr & OERR) {
	fprintf(stderr, "overrun error\n");
    }
    else if (sioerr & FERR) {
	fprintf(stderr, "framing error\n");
    }
    sioerr = 0;
#ifdef TTY_ESC_CHK
    if (kbhit()) {
	ch = getch();
	if (ch == ESCAPE) {
	    ttyrestore(intr_port);
	    exit(3);
	}
    }
#endif
    if (ringsiz <= 0) {
	ch = EOF;
    }
    else {
	disable();
	ch = ringbuf[ringtop];
	++ringtop;
	--ringsiz;
#ifdef RTSCTS	/* */
	if (ringsiz < RINGSIZ / 4) {
	    flowctl(FLOW_START);
	}
#endif	/* */
	if (ringtop >= RINGSIZ) {
	    ringtop = 0;
	}
	enable();
    }
    return(ch);
}


/* M荞݂𒆎~ */
void reset_intr()
{
    disable();
    outp(PICIMR, save_mask);
    setvect(sio_intr(intr_port), save_vec);
    enable();
}
#endif


/* VA|[g̃Zbg */
void ttyrestore(int port)
{
#ifdef USE_INTR
    reset_intr();
#endif
#ifdef EBUG
    fprintf(stderr, "tty #%d closed\n", port);
#endif
}


/* VA|[g */
int closetty(int port)
{
    ttyrestore(port);	/* ӖȂ? ݊̂ */
    return(0);
}


/* 8250ݒ */
void ttyinit(int port, long bps)
{
    init8250(port, bps);
    sioerr = 0;
#ifdef USE_INTR
    set_intr(port);
    atexit(reset_intr);
#endif
#ifdef EBUG
    fprintf(stderr, "port %d initialized at %d bps\n", port, bps);
#endif
}
