#include	<stdio.h>
#include	<string.h>
#include	<ctype.h>
#include	<math.h>
// 2000/07/16 Warning̏C
// 2001/06/12 VPP,VCCo͂̕ϊe[up~

#define	DA_TABLE_MAX	30

static	struct	{
	long	f;
	unsigned	char	d;
} DAtable[3][2][DA_TABLE_MAX];
static	int	DAcount[3][2] = { {0, 0}, {0, 0}, {0, 0} };

static	int	Pin2port[41];
static	int	Vpp2port[41];
static	int	Vcc2port[41];
static	int	Gnd2port[41];

#ifndef	MAIN
extern  int	SetSymData( unsigned char *p );
extern  int do_define(void);
#endif

/* float100{long^ŕԑ */
int	float2long( char *data )
{
	char	*p;

	p = strchr( data, '.' );
	if( p == NULL ) {
		strcat( data, "00" );
	} else {
		if( *(p+1) == 0 ) {
			*p     = '0';
			*(p+1) = '0';
			*(p+2) = 0;
		} else if( *(p+2) == 0 ) {
			*p = *(p+1);
			*(p+1) = '0';
			*(p+2) = 0;
		} else {
			*p = *(p+1);
			*(p+1) = *(p+2);
			*(p+2) = 0;
		}
	}
	return(0);
}

int	pinno2port( int pin )
{
	if( pin <= 40 ) {
		return( Pin2port[ pin ] );
	}
	if( pin <= 80 ) {
		return( Vpp2port[ pin-40 ] );
	}
	if( pin <= 120 ) {
		return( Vcc2port[ pin-80 ] );
	}
	if( pin <= 160 ) {
		return( Gnd2port[ pin-120 ] );
	}
	return( 0xff );
}

int	deffileload( char *name )
{
	FILE	*fp;
	int		i, flg, d, H, L, pin, board;
	char	buff[256], temp[256], *p;
	long	f;

	DAcount[0][0] = 0;
	DAcount[0][1] = 0;
	DAcount[1][0] = 0;
	DAcount[1][1] = 0;
	DAcount[2][0] = 0;
	DAcount[2][1] = 0;
	board = 0;

	for( i=0; i<41; i++ ) {
		Pin2port[i] = 0xff;
		Vpp2port[i] = 0xff;
		Vcc2port[i] = 0xff;
		Gnd2port[i] = 0xff;
	}

	if( (fp=fopen( name, "r" )) == NULL ) {
		return(-1);
	}
	while( fgets( buff, 256, fp ) != NULL ) {
		flg = -1;
		if( strnicmp( buff, "#CVPP", 5 ) == 0 ) {
			flg = 0;
			p = buff+5;
		} else if( strnicmp( buff, "#CVCC", 5 ) == 0 ) {
			flg = 1;
			p = buff+5;
		} else if( strnicmp( buff, "#VPP", 4 ) == 0 ) {
			flg = 2;
			p = buff+4;
		} else if( strnicmp( buff, "#VCC", 4 ) == 0 ) {
			flg = 3;
			p = buff+4;
		} else if( strnicmp( buff, "#GND", 4 ) == 0 ) {
			flg = 4;
			p = buff+4;
		} else if( *buff == '#' && isdigit( *(buff+1) ) ) {
			flg = 5;
			p = buff+1;
		} else if( strnicmp( buff, "#define", 7 ) == 0 ) {
			flg = 6;
			p = buff+7;
		} else if( strnicmp( buff, "[Board1]", 8 ) == 0 ) {
			board = 0;
			continue;
		} else if( strnicmp( buff, "[Board2]", 8 ) == 0 ) {
			board = 1;
			continue;
		} else if( strnicmp( buff, "[Board3]", 8 ) == 0 ) {
			board = 2;
			continue;
		}
		switch( flg ) {
		case	0:	/* #CVPP */
		case	1:	/* #CVCC */
			*temp = 0;
			if( sscanf( p, "%s %d", temp, &d ) != 2 ) {
				break;
			}
			if( float2long( temp ) != 0 ) {
				break;
			}
			sscanf( temp, "%ld", &f );
			if( DAcount[board][flg] >= DA_TABLE_MAX ) {
				break;
			}
			DAtable[board][flg][ DAcount[board][flg] ].f = f;
			DAtable[board][flg][ DAcount[board][flg] ].d = (unsigned char)d;
			DAcount[board][flg]++;
			break;
		case	2:	/* #VPPxx */
		case	3:	/* #VCCxx */
		case	4:	/* #GNDxx */
		case	5:	/* #xx */
			sscanf( p, "%d", &pin );
			if( pin < 1 || pin > 40 ) {
				break;
			}
			while( isdigit( *p ) ) {
				p++;
			}
			while( isspace( *p ) ) {
				p++;
			}
			if( sscanf( p, "%x", &d ) != 1 ) {
				break;
			}
			H = d/16;
			L = d%16;
			if( H < 1 || H == 7 || H == 9 || H > 11 || L > 7 ) {
				break;
			}
			if( H <= 6 ) {
				H--;
			} else if( H == 8 ) {
				H-=2;
			} else {
				H-=3;
			}
			d = (H<<3)|L;	/* 0`159ɕϊ */
			switch( flg ) {
			case	2:	/* #VPPxx */
				Vpp2port[pin] = d;
				break;
			case	3:	/* #VCCxx */
				Vcc2port[pin] = d;
				break;
			case	4:	/* #GNDxx */
				Gnd2port[pin] = d;
				break;
			case	5:	/* #xx */
				Pin2port[pin] = d;
				break;
			}
			break;
		case	6:	/* #define */
#ifndef	MAIN
			SetSymData( (unsigned char *)p );
			if( do_define() != 0 ) {
				fclose( fp );
				return(-1);
			}
#endif
			break;
		default:
			break;
		}
	}
	fclose( fp );
	return(0);
}

/* 0:VPP,1:VCC "12.25" */
int	DAC( int board, int side, char *dt )
{
	int		i, y;
	long	sa, a, b, t;
	struct	{
		long	sa;
		long	f;
		unsigned	char	d;
	} table[3];
	char	temp[256];

	if( board < 0 || board > 2 ) {
		return(-1);
	}
	if( side < 0 || side > 1 ) {
		return(-1);
	}
	strcpy( temp, dt );
	if( float2long( temp ) != 0 ) {
		return(-1);
	}
	sscanf( temp, "%ld", &t );

	if( t != 0 && (t<500 || t>2100) ) {
		return(-1);
	}
	return( t/10 );
#if 0
	table[0].sa = 9999;
	table[1].sa = 9999;
	/* ԋ߂lQo */
	for( i=0; i<DAcount[board][side]; i++ ) {
		sa = labs(DAtable[board][side][i].f-t);
		if( table[0].sa == 9999 ) {
			table[0].sa = sa;
			table[0].f = DAtable[board][side][i].f;
			table[0].d = DAtable[board][side][i].d;
			continue;
		}
		if( table[1].sa == 9999 ) {
			table[1].sa = sa;
			table[1].f = DAtable[board][side][i].f;
			table[1].d = DAtable[board][side][i].d;
			continue;
		}
		if( table[0].sa > table[1].sa ) {
			table[2] = table[1];
			table[1] = table[0];
			table[0] = table[2];
		}
		if( table[0].sa > sa ) {
			table[1] = table[0];
			table[0].sa = sa;
			table[0].f = DAtable[board][side][i].f;
			table[0].d = DAtable[board][side][i].d;
		} else if( table[1].sa > sa ) {
			table[1].sa = sa;
			table[1].f = DAtable[board][side][i].f;
			table[1].d = DAtable[board][side][i].d;
		}
	}
	/* vĂf[^ȂvZȂŌʂԂ */
	if( table[0].f == t ) {
		return( table[0].d );
	}
	if( table[1].f == t ) {
		return( table[1].d );
	}
	/* f[^QmF */
	if( table[0].sa == 9999 || table[1].sa == 9999 ) {
		/* ɂ͉vZɂݒt point */
		return(-1);
	}
	/* 傫f[^Pɂ */
	if( table[0].f > table[1].f ) {
		table[2] = table[1];
		table[1] = table[0];
		table[0] = table[2];
	}
	/* rԂČʂvZ */
	a = (long)(table[1].d-table[0].d)*1000000L/(table[1].f-table[0].f);
	b = table[0].d*1000000L - (a * table[0].f);
	y = (unsigned char)((a * t + b)/1000000L);
	return( y );
#endif
}

#ifdef	MAIN
int	main()
{
	int	rc;
	char	buff[100];

	deffileload( "control.dat" );
	rc = DAC( 0, 0, "12.7" );
	printf( "set = %d\n", rc );
	return(0);
}
#endif