#include	<stdio.h>
#include	<malloc.h>
#include	<string.h>

/* nbVe[uTCYɂ͑fgpČIɊi[ */
/* 97,241,397,499,743,997,1499,1999,3989,4999,7499,9973 */
#define	HASHSIZE	97

static	int	Malloc = 0;
static	int	Free = 0;
static	int	HashInitFlag = 1;

typedef	struct link {
	unsigned	char	*name;
	unsigned	char	*data;
	unsigned	char	flags;
	struct	link	*next;
} Link;

Link	HashTbl[HASHSIZE];
int		InitHash(void);
int		DestroyHash(void);

int		InitHash(void)
{
	int		n;

	if( HashInitFlag == 1 ) {
		for( n=0; n<HASHSIZE; n++ ) {
			HashTbl[n].name = NULL;
			HashTbl[n].data = NULL;
			HashTbl[n].flags = 0;
			HashTbl[n].next = NULL;
		}
		HashInitFlag = 0;
	} else {
		DestroyHash();
	}
	return(0);
}

int		DestroyHash(void)
{
	int		n;
	Link	*ptr, *ptr2;

	if( HashInitFlag == 1 ) {
		InitHash();
		return(0);
	}
	for( n=0; n<HASHSIZE; n++ ) {
		if( HashTbl[n].name != NULL ) {
			free( HashTbl[n].name );
Free++;
			HashTbl[n].name = NULL;
		}
		if( HashTbl[n].data != NULL ) {
			free( HashTbl[n].data );
Free++;
			HashTbl[n].data = NULL;
		}
		HashTbl[n].flags = 0;
		ptr = HashTbl[n].next;
		while( ptr != NULL ) {
			if( ptr->name != NULL ) {
				free( ptr->name );
Free++;
			}
			if( ptr->data != NULL ) {
				free( ptr->data );
Free++;
			}
			ptr->flags = 0;
			if( ptr->next != NULL ) {
				ptr2 = ptr->next;
				free( ptr );
Free++;
				ptr = ptr2;
			} else {
				free( ptr );
Free++;
				break;
			}
		}
		HashTbl[n].next = NULL;
	}
	return(0);
}

unsigned	long	ElfHash( unsigned char *name )
{
	unsigned	long	h=0, g;

	while( *name ) {
		h = (h<<4) + *name++;
//		if( g = h & 0xf0000000 ) {
		g = h & 0xf0000000;
		if( g ) {
			h ^= g>>24;
		}
		h &= ~g;
	}
	return( h );
}

int		AddHash( char *p, unsigned char *d, unsigned char flags )
{
	long	key;
	Link	*hash;
	unsigned	char	*name;


	name = (unsigned char *)p;

	key = ElfHash( name ) % HASHSIZE;
	hash = &HashTbl[key];
	while( 1 ) {
		if( hash->name == NULL ) {
			if( (hash->name=(unsigned char *)malloc(strlen((char *)name)+1)) == NULL ) {
				return(-1);
			}
Malloc++;
			strcpy( (char *)hash->name, (char *)name );
			if( d != NULL ) {
				if( (hash->data=(unsigned char *)malloc( strlen((char *)d)+1 )) == NULL ) {
					return(-1);
				}
Malloc++;
				strcpy( (char *)hash->data, (char *)d );
			}
			hash->flags = flags;
			return(0);
		}
		/* f[^L΃tO̕ύXɂ */
		if( strcmp( (char *)hash->name, (char *)name ) == 0 ) {
			if( d != NULL ) {
				if( hash->data != NULL ) {
					free( hash->data );
					hash->data = NULL;
				}
				if( (hash->data=(unsigned char *)malloc( strlen((char *)d)+1 )) == NULL ) {
					return(-1);
				}
Malloc++;
				strcpy( (char *)hash->data, (char *)d );
			}
			hash->flags = flags;
			return(0);
		}
		if( hash->next == NULL ) {
			if( (hash->next=(Link *)malloc(sizeof(Link))) == NULL ) {
				return(-1);
			}
Malloc++;
			hash = hash->next;
			hash->name = NULL;
			hash->data = NULL;
			hash->flags = 0;
			hash->next = NULL;
		} else {
			hash = hash->next;
		}
	}
}

int		SearchHash( char *p )
{
	long	key;
	Link	*hash;
	unsigned	char	*name;

	name = (unsigned char *)p;
	key = ElfHash( name ) % HASHSIZE;
	hash = &HashTbl[key];
	while( 1 ) {
		if( hash->name == NULL ) {
			return(-1);
		}
		if( strcmp( (char *)hash->name, (char *)name ) == 0 ) {
			return( hash->flags );
		}
		if( hash->next == NULL ) {
			return(-1);
		}
		hash = hash->next;
	}
}

int		SearchHashData( char *p, unsigned char *d )
{
	long	key;
	Link	*hash;
	unsigned	char	*name;

	name = (unsigned char *)p;
	key = ElfHash( name ) % HASHSIZE;
	hash = &HashTbl[key];
	while( 1 ) {
		if( hash->name == NULL ) {
			return(-1);
		}
		if( strcmp( (char *)hash->name, (char *)name ) == 0 ) {
			if( hash->data == NULL || d == NULL ) {
				return(-1);
			}
			strcpy( (char *)d, (char *)hash->data );
			return( hash->flags );
		}
		if( hash->next == NULL ) {
			return(-1);
		}
		hash = hash->next;
	}
}

int		DeleteHash( char *p )
{
	long	key;
	Link	*hash, *ptr;
	unsigned	char	*name;

	name = (unsigned char *)p;
	key = ElfHash( name ) % HASHSIZE;
	hash = &HashTbl[key];
	while( 1 ) {
		if( hash->name == NULL ) {
			return(-1);
		}
		if( strcmp( (char *)hash->name, (char *)name ) == 0 ) {
			free( hash->name );
Free++;
			hash->name = NULL;
			if( hash->data != NULL ) {
				free( hash->data );
Free++;
				hash->data = NULL;
			}
			hash->flags = 0;
			if( hash->next != NULL ) {
				hash->name = hash->next->name;
				hash->data = hash->next->data;
				hash->flags = hash->next->flags;
				ptr = hash->next->next;
				free( hash->next );
Free++;
				hash->next = ptr;
			}
			return(0);
		}
		if( hash->next == NULL ) {
			return(-1);
		}
		hash = hash->next;
	}
}

#if 0

int		main()
{
	int		rc;

	InitHash();

	rc = AddHash( "aabbcc", NULL, 1 );	printf( "rc = %d\n", rc );
	rc = AddHash( "aabbc1", NULL, 2 );	printf( "rc = %d\n", rc );
	rc = AddHash( "aabbc2", NULL, 3 );	printf( "rc = %d\n", rc );
	rc = AddHash( "aabbc3", NULL, 4 );	printf( "rc = %d\n", rc );
	rc = AddHash( "aabbc4", NULL, 5 );	printf( "rc = %d\n", rc );
	rc = AddHash( "aabbc5", NULL, 6 );	printf( "rc = %d\n", rc );
	rc = SearchHash( "aabbcc" );	printf( "ans rc = %d\n", rc );
	rc = SearchHash( "aabbc1" );	printf( "ans rc = %d\n", rc );
	rc = SearchHash( "aabbc2" );	printf( "ans rc = %d\n", rc );
	rc = DeleteHash( "aabbc3" );	printf( "Del rc = %d\n", rc );
	rc = SearchHash( "aabbc3" );	printf( "ans rc = %d\n", rc );
	rc = SearchHash( "aabbc4" );	printf( "ans rc = %d\n", rc );
	rc = SearchHash( "aabbc5" );	printf( "ans rc = %d\n", rc );
	rc = SearchHash( "aabbc6" );	printf( "ans rc = %d\n", rc );

	DestroyHash();

	printf( "\n" );
	printf( "malloc() = %d\n", Malloc );
	printf( "free()   = %d\n", Free );
	return(0);
}

#endif
