#include	<stdio.h>
#include	<string.h>
#include	<ctype.h>
#include	"hex.h"

/* PsɉoCgo͂邩̎w */
static	int	HexLineMax = 16;
/* ihex_out 鎞ɂPsŜFFȂXLbv邩ǂ̎w(1:skip) */
static	int	SkipFF = 1;

static	char	Hex_bf[2][90];

int	ihex_mode( int mode )
{
	switch( mode ) {
	case	1:
		HexLineMax = 16;
		SkipFF = 0;
		break;
	case	2:
		HexLineMax = 16;
		SkipFF = 1;
		break;
	case	3:
		HexLineMax = 32;
		SkipFF = 0;
		break;
	case	4:
		HexLineMax = 32;
		SkipFF = 1;
		break;
	default:
		return( -1 );
	}
	if( HexLineMax == 16 ) {
		if( SkipFF == 0 ) {
			return( 1 );
		} else {
			return( 2 );
		}
	} else {
		if( SkipFF == 0 ) {
			return( 3 );
		} else {
			return( 4 );
		}
	}
}

void	ihex_end( FILE *fp )
{
	if( fp == NULL ) {
		printf( ":00000001FF\n" );
	} else {
		fprintf( fp, ":00000001FF\n" );
	}
}

void	ihex_out( int side, FILE *fp )
{
	int		sum = 0, len, n, dt;
	char	temp[5];

	len = strlen( Hex_bf[side] );
	if( len == 0 ) {
		return;
	}
	if( SkipFF != 0 ) {
		if( strncmp( &Hex_bf[side][7], "00", 2 ) == 0 ) {
			for( n=9; n<len; n+=2 ) {
				if( strncmp( &Hex_bf[side][n], "FF", 2 ) != 0 ) {
					break;
				}
			}
			if( n >= len ) {
				*Hex_bf[side] = 0x00;
				return;
			}
		}
	}
	sprintf( temp, "%02X", (len-9)/2 );
	strncpy( &Hex_bf[side][1], temp, 2 );
	for( n=1; n<len; n+=2 ) {
		strncpy( temp, &Hex_bf[side][n], 2 );
		sscanf( temp, "%x", &dt );
		sum += dt;
		sum &= 0xff;
	}
	sum = (0x100 - sum) & 0xff;
	sprintf( &Hex_bf[side][strlen(Hex_bf[side])], "%02X", sum );
	if( fp == NULL ) {
		printf( Hex_bf[side] );
		printf( "\n" );
	} else {
		fprintf( fp, Hex_bf[side] );
		fprintf( fp, "\n" );
	}
	*Hex_bf[side] = 0x00;
}

void	ihex( int side, unsigned long adr, unsigned	char dt, FILE *fp )
{
	static	int	init_flg[2] = { 1, 1 };
	static	unsigned	long	offset[2], old_adr[2];

	if( init_flg[side] ) {
		init_flg[side] = 0;
		*Hex_bf[side] = 0x00;
		offset[side] = 0L;
		old_adr[side] = adr-1L;
	}
	for( ;; ) {
		if( adr >= offset[side] ) {
			if( (adr-offset[side]) > 0xffffL ) {
				offset[side] = (adr & 0xffff0000L);
				ihex_out( side, fp );
				sprintf( Hex_bf[side], ":  000002%lX", (offset[side]/16L) );
				if( (strlen( Hex_bf[side] ) % 2) == 0 ) {
					sprintf( Hex_bf[side],":  0000020%lX",(offset[side]/16L) );
				}
				ihex_out( side, fp );
			}
			break;
		} else {
			ihex_out( side, fp );
			offset[side] = 0;
		}
	}
	if( *Hex_bf[side] != 0x00 ) {
		if( (int)strlen( Hex_bf[side] ) < (9+(HexLineMax*2)) ) {
			if( (old_adr[side]+1) == adr ) {
				sprintf( &Hex_bf[side][strlen(Hex_bf[side])], "%02X", dt );
				old_adr[side] = adr;
				return;
			}
		}
		ihex_out( side, fp );
	}
	sprintf( Hex_bf[side], ":  %04lX00%02X", (long)(adr-offset[side]), dt );
	old_adr[side] = adr;
	return;
}

int	str2byte( char *buff )
{
	int		rc;
	char	temp[3];

	memcpy( temp, buff, 2 );
	temp[2] = 0;
	sscanf( temp, "%x", &rc );
	return(rc);
}

int	bin_convert( unsigned char *dst, char *src )
{
	if( *src != ':' ) {
		return(-1);
	}
	if( strlen( src ) < 11 ) {
		return(-1);
	}
	src++;
	while( isalnum(*src) ) {
		*dst = (unsigned char)str2byte( src );
		dst++;
		src += 2;
	}
	return(0);
}

int	ReadData(	// 0:A-1:ُ
	int		flg,			// 0:A1:p
	FILE	*fp,			// ǂݍ݃t@C|C^
	long	*radr,			// ǂݍ񂾃f[^̊JnAhX
	unsigned char	*data,	// ǂݍ񂾃f[^
	int 	*len )			// :őǂݍݒAo:ۂ̓ǂݍݒ
{
	char	buff[256];
	unsigned char	bin[128];
	int		i, type, datalen, dataptr;
	long	dataadr, adr;
	static	long	segment = 0, seekptr;

	if( flg == 0 ) {
		segment = 0;	// ̌Ăяo
	} else {
		fseek( fp, seekptr, 0 );
	}
	dataptr = 0;	// ̃f[^ݒ萔
	for( ;; ) {
		seekptr = ftell(fp);
		if( fgets( buff, 256, fp ) == NULL ) {
			break;
		}
		if( bin_convert( bin, buff ) != 0 ) {
			continue;
		}
		// :LLAAAATTDD..DDSS
		datalen = bin[0];
		dataadr = segment;
		dataadr += (long)(bin[1])<<8;
		dataadr += (long)bin[2];
		type = bin[3];
		if( type == 0 ) {		// f[^
			if( dataptr == 0 ) {
				adr = dataadr;	// AhX
			}
			if( (adr+dataptr) != dataadr ) {
				// AhXAĂȂ
				*len = dataptr;
				*radr = adr;
				if( *len == 0 ) {
					*radr = 0;
				}
				return(0);
			}
			if( (dataptr+datalen) > *len ) {
				// ̊i[ő咷ɒB
				*len = dataptr;
				*radr = adr;
				if( *len == 0 ) {
					*radr = 0;
				}
				return(0);
			}
			// păf[^i[
			for( i=0; i<datalen; i++ ) {
				data[dataptr++] = bin[i+4];
			}
		} else if( type == 1 ) {	// f[^̏I
			*len = dataptr;
			*radr = adr;
			if( *len == 0 ) {
				*radr = 0;
			}
			return(0);
		} else if( type == 2 ) {	// gAhXw
			segment = 0;
			for( i=0; i<datalen; i++ ) {
				segment <<= 8;
				segment += (unsigned long)bin[i+4];
			}
			segment *= 16;
		} else {
			return(-1);		// tH[}bgُ
		}
	}
	*len = dataptr;
	*radr = adr;
	if( *len == 0 ) {
		*radr = 0;
	}
	return(0);
}

#ifdef	DEBUG1
int	main(int ar,char *av[])
{
	FILE	*fp;
	int		rc, flg, i;
	int		len, sum;
	long	adr;
	unsigned	char	data[256];

	if( ar != 2 ) {
		printf( "t@Cw肵ĉ\n" );
		return(0);
	}
	if( (fp=fopen(av[1],"r")) == NULL ) {
		printf( "t@CI[vُ\n" );
		return(0);
	}
	sum = 0;
	flg = 0;
	for( ;; ) {
		len = 256;	// őǂݍݒ
		rc = ReadData( flg, fp, &adr, data, &len );
		flg = 1;

printf( "adr = 0x%lX   len = %d   \n", adr, len );
/*
			for( i=0; i<5; i++ ) {
printf( "[%d]=%x  ", i, data[i] );
			}
printf( "\n" );
*/
/*
		printf( "rc = %d  adr = %lX  len = %2d    ", rc, adr, len );
		sum += len;
		for( i=0; i<len; i++ ) {
			printf( "%02X", data[i] );
		}
		printf( "\n" );
*/
		if( len == 0 || rc == -1 ) {
			break;
		}
	}
	fclose( fp );
	printf( "sum = %d\n", sum );
	return(0);
}
#endif

#ifdef	DEBUG2
int		main(int ar, char *av[])
{
	unsigned	int	a, len;

	if( ar != 2 ) {
		fprintf( stderr, "%s size\n", av[0] );
		return(1);
	}
	if( strncmp( av[1], "0x", 2 ) == 0 || strncmp( av[1], "0X", 2 ) == 0 ) {
		sscanf( &av[1][2], "%x", &len );
	} else {
		sscanf( av[1], "%d", &len );
	}
	for( a=0; a<len; a++ ) {
		ihex( 0, (long)a, (unsigned char)(a&0xff), NULL );
	}
	ihex_out( 0, NULL );
	ihex_end( NULL );
	return( 0 );
}
#endif

#ifdef	DEBUG3
int		main(int ar, char *av[])
{
	unsigned	int	a, len, len2;

	if( ar != 3 ) {
		fprintf( stderr, "%s FF_size dt_size\n", av[0] );
		return(1);
	}
	if( strncmp( av[1], "0x", 2 ) == 0 || strncmp( av[1], "0X", 2 ) == 0 ) {
		sscanf( &av[1][2], "%x", &len );
	} else {
		sscanf( av[1], "%d", &len );
	}
	if( strncmp( av[2], "0x", 2 ) == 0 || strncmp( av[2], "0X", 2 ) == 0 ) {
		sscanf( &av[2][2], "%x", &len2 );
	} else {
		sscanf( av[2], "%d", &len2 );
	}
	for( a=0; a<len; a++ ) {
		ihex( 0, (long)a, 0xff, NULL );
	}
	for( a=len; a<(len+len2); a++ ) {
		ihex( 0, (long)a, 0x12, NULL );
	}
	ihex_out( 0, NULL );
	ihex_end( NULL );
	return( 0 );
}
#endif
