#include	<stdio.h>
#include	<string.h>
#include	"sym.h"

unsigned	char	symtbl[256];
#define	U	0x00		/*	NG						*/
#define	Q	0x00		/*	PRIORITY <				*/
#define	P	0x01		/*	PRIORITY >=				*/
#define	M	0x80		/*	COMBI OK ??				*/
#define	T	0x81		/*	COMBI OK,PRIORITY >=	*/
/*	1XXXXXX1	*/
/*	I      I----PRIORITY BIT(1:>=,0:<)	*/
/*	i-----------COMBINATION CHECK BIT(1:OK)	*/
unsigned	char	pritbl[16][16] = {
/*	 0 1 2 3 4 5 6 7 8 9 A B C D E F			CURRENT		*/
	{T,P,P,P,P,P,P,P,P,P,P,P,P,P,P,T},	/*	0:, : C/R	*/
	{T,P,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,M},	/*	1:			*/
	{P,T,M,M,M,M,M,M,M,M,M,M,M,M,M,U},	/*	2:- UNARY	*/
	{T,P,P,P,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,M},	/*	3:* /		*/
	{T,P,P,P,P,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,M},	/*	4:\			*/
	{T,P,P,P,P,P,Q,Q,Q,Q,Q,Q,Q,Q,Q,M},	/*	5:MOD		*/
	{T,P,P,P,P,P,P,Q,Q,Q,Q,Q,Q,Q,Q,M},	/*	6:+ -		*/
	{T,P,P,P,P,P,P,P,Q,Q,Q,Q,Q,Q,M,M},	/*	7:> = <>	*/
	{T,P,P,P,P,P,P,P,P,Q,Q,Q,Q,Q,M,M},	/*	8:NOT		*/
	{T,P,P,P,P,P,P,P,P,P,Q,Q,Q,Q,Q,M},	/*	9:AND		*/
	{T,P,P,P,P,P,P,P,P,P,P,Q,Q,Q,Q,M},	/*	A:OR		*/
	{T,P,P,P,P,P,P,P,P,P,P,P,Q,Q,Q,M},	/*	B:XOR		*/
	{T,P,P,P,P,P,P,P,P,P,P,P,P,Q,Q,M},	/*	C:EQV		*/
	{T,P,P,P,P,P,P,P,P,P,P,P,P,P,Q,M},	/*	D:IMP		*/
	{U,M,M,M,M,M,M,M,M,M,M,M,M,M,M,M},	/*	E:( LETEQ ,	*/
	{M,M,M,M,M,M,M,M,M,M,M,M,M,M,M,U}		/*	F:FUNC		*/
};

#define	POL_STACK	50					/*	X^bN	*/
#define	PTR_SIZE	150					/*	o̓GA	*/

void	pol_init(void)						/*	D揇ʂ̐ݒ	*/
{
	int		n;

	for( n=0; n<256; n++ ) {
		symtbl[n] = 0xff;
	}
	symtbl[S_RPAR]   = 0;						/*	)					*/
	symtbl[M_TIMES]  = symtbl[M_SLASH]  = 3;	/*	*  /				*/
	symtbl[M_MOD]    = 3;						/*	%					*/
	symtbl[M_INC]    = symtbl[M_DEC]    = 5;	/*	++ --				*/
	symtbl[M_NOT]    = 5;						/*	!					*/
	symtbl[M_BITREV] = 5;						/*	~					*/
	symtbl[M_PLUS]   = symtbl[M_MINUS]  = 6;	/*	+  -				*/
	symtbl[M_SHIFTL] = symtbl[M_SHIFTR] = 6;	/*	<< >>				*/
	symtbl[M_CMP]    = symtbl[M_NEQ]    = 7;	/*	== !=				*/
	symtbl[M_GTR]    = symtbl[M_LSS]    = 7;	/*	>  <				*/
	symtbl[M_GEQ]    = symtbl[M_LEQ]    = 7;	/*	>= <=				*/
	symtbl[M_AND]    = 9;						/*	&&					*/
	symtbl[M_OR]     = 10;						/*	||					*/
	symtbl[M_BITAND] = 12;						/*	&					*/
	symtbl[M_BITOR]  = symtbl[M_BITXOR]  = 13;	/*	|  ^				*/
	symtbl[S_LPAR]   = symtbl[M_EQL]    = 14;	/*	(  =				*/
	symtbl[M_TIMESEQL]=symtbl[M_SLASHEQL] =14;	/*	*= /=				*/
	symtbl[M_ANDEQL] = symtbl[M_OREQL] =14;		/*	&= |=				*/
	symtbl[M_XOREQL] = 14;						/*	^=					*/
	symtbl[M_PLUSEQL]= symtbl[M_MINUSEQL] =14;	/*	+= -=				*/
	symtbl[S_STR]    = 15;						/*					*/
	symtbl[S_MSG]    = 15;						/*					*/
	symtbl[M_CHAR]   = symtbl[M_SHORT]  = 15;	/*	l				*/
	symtbl[M_INT]    = symtbl[M_LONG]   = 15;	/*	l				*/
	symtbl[M_FLOAT]  = 15;						/*	l				*/
}

int		pol( char *dat[], int cnt )
{
	int		op, j;
	char	*s[POL_STACK];			/*	X^bN			*/
	char	*od[PTR_SIZE];			/*	o̓GA			*/
	unsigned	char	rc, tmp[2];
	int		loop;

	op = 0;						/*	o͐|C^	*/
	tmp[0] = S_LPAR;
	s[0] = (char *)tmp;							/*	ŏ ( ɂ		*/
	j = 1;								/*	X^bN|C^	*/
	for( loop=0; loop<cnt; loop++ ) {
		rc = dat[loop][0];
		if( (rc > M_START && rc < M_END) || rc == S_LPAR || rc == S_RPAR ) {
			while( 1 ) {
				if( symtbl[ dat[loop][0] ] == 0xff ) {
					return(-1);
				}
				if( symtbl[ s[j-1][0] ] == 0xff ) {
					return(-1);
				}
				rc = pritbl[ symtbl[dat[loop][0]] ][ symtbl[s[j-1][0]] ];
				if( rc == 81 ) {
					return(-1);
				}
				if( rc == 0 || rc == 0x80 ) {
					if( j >= POL_STACK ) {
						return(-1);
					}
					/* Zqo */
					s[j] = dat[loop];
					j++;
				} else {
					if( s[j-1][0] == S_LPAR ) {
						if( j == 1 ) {
							return(-1);
						}
						j--;
					} else {
						/*X^bN牉Zqoďo̓GAɏ*/
						/* o */
						od[op] = s[j-1];
						op++;
						j--;
						continue;
					}
				}
				break;
			}
		} else {
			od[op] = dat[loop];/* 萔Aϐo̓GAɏo */
			op++;
		}
	}
	/*	X^bNɎcĂf[^̏o	*/
	for( ;j > 1; j-- ) {
		od[op++] = s[j-1];
	}
	/*	̃f[^GAƕϊʂꊷ	*/
	for( loop=0; loop<cnt; loop++ ) {
		dat[loop] = od[loop];
	}
#if	0
	/* vZł鍀ڂ͂ŌvZĂ܂ */
	do {
		flg = 0;
		/* vZł鏊܂Ői߂ */
		ptr = 0;
		while( op > ptr && dat[ptr][0] >= M_CHAR && dat[ptr][0] <= M_LONG ) {
			ptr++;
		}
		/* ptr ͐l̍ŌĂ */
		ptr--;
		if( ptr < 0 ) {
			break;
		}
		sscanf( &dat[ptr][1], "%ld", &data1 );
		switch( dat[ptr+1][0] ) {
		case	M_INC:		/*  ++  */
			data1++;
			flg = 1;
			break;
		case	M_DEC:		/*  --  */
			data1--;
			flg = 1;
			break;
		case	M_BITREV:	/*  ~   */
			data1 = ~data1;
			flg = 1;
			break;
		case	M_NOT:		/*  !   */
			if( data1 ) {
				data1 = 0;
			} else {
				data1 = (1==1);
			}
			flg = 1;
			break;
		default:
			break;
		}
		if( flg == 1 ) {
			switch( dat[ptr][0] ) {
			case	M_CHAR:
				sprintf( &dat[ptr][1], "%ld", (data1&0xff) );
				break;
			case	M_INT:
				sprintf( &dat[ptr][1], "%ld", (data1&0xffff) );
				break;
			case	M_LONG:
				sprintf( &dat[ptr][1], "%ld", (data1&0xffffff) );
				break;
			}
			for( j=ptr; j<(op-1); j++ ) {
				dat[j+1] = dat[j+2];
			}
			op--;
			continue;
		}
		if( op > ptr && ptr > 0 && dat[ptr-1][0] >= M_CHAR && dat[ptr-1][0] <= M_LONG ) {
			sscanf( &dat[ptr-1][1], "%ld", &data1 );
			sscanf( &dat[ptr][1], "%ld", &data2 );
			switch( dat[ptr+1][0] ) {
			case	M_PLUS:		/*  +   */
				data1 += data2;
				flg = 1;
				break;
			case	M_MINUS:	/*  -   */
				data1 -= data2;
				flg = 1;
				break;
			case	M_SLASH:	/*  /   */
				data1 /= data2;
				flg = 1;
				break;
			case	M_TIMES:	/*  *   */
				data1 *= data2;
				flg = 1;
				break;
			case	M_MOD:		/*  %   */
				data1 %= data2;
				flg = 1;
				break;
			case	M_NEQ:		/*  !=  */
				if( data1 != data2 ) {
					data1 = (1==1);
				} else {
					data1 = 0;
				}
				flg = 1;
				break;
			case	M_GEQ:		/*  >=  */
				if( data1 >= data2 ) {
					data1 = (1==1);
				} else {
					data1 = 0;
				}
				flg = 1;
				break;
			case	M_GTR:		/*  >   */
				if( data1 > data2 ) {
					data1 = (1==1);
				} else {
					data1 = 0;
				}
				flg = 1;
				break;
			case	M_LEQ:		/*  <=  */
				if( data1 <= data2 ) {
					data1 = (1==1);
				} else {
					data1 = 0;
				}
				flg = 1;
				break;
			case	M_LSS:		/*  <   */
				if( data1 < data2 ) {
					data1 = (1==1);
				} else {
					data1 = 0;
				}
				flg = 1;
				break;
			case	M_CMP:		/*  ==  */
				if( data1 == data2 ) {
					data1 = (1==1);
				} else {
					data1 = 0;
				}
				flg = 1;
				break;
			case	M_SHIFTL:	/*  <<  */
				data1 <<= data2;
				flg = 1;
				break;
			case	M_SHIFTR:	/*  >>  */
				data1 >>= data2;
				flg = 1;
				break;
			case	M_AND:		/*  &&  */
				if( data1 && data2 ) {
					data1 = (1==1);
				} else {
					data1 = 0;
				}
				flg = 1;
				break;
			case	M_BITAND:	/*  &   */
				data1 &= data2;
				flg = 1;
				break;
			case	M_OR:		/*  ||  */
				if( data1 || data2 ) {
					data1 = (1==1);
				} else {
					data1 = 0;
				}
				flg = 1;
				break;
			case	M_BITOR:	/*  |   */
				data1 |= data2;
				flg = 1;
				break;
			default:
				break;
			}
			if( flg == 1 ) {
				if( dat[ptr-1][0] == M_LONG || dat[ptr][0] == M_LONG ) {
					dat[ptr-1][0] = M_LONG;
					sprintf( &dat[ptr-1][1], "%ld", (data1&0xffffff) );
				} else if( dat[ptr-1][0] == M_INT || dat[ptr][0] == M_INT ) {
					dat[ptr-1][0] = M_INT;
					sprintf( &dat[ptr-1][1], "%ld", (data1&0xffff) );
				} else {
					dat[ptr-1][0] = M_CHAR;
					sprintf( &dat[ptr-1][1], "%ld", (data1&0xff) );
				}
				for( j=ptr; j<(op-1); j++ ) {
					dat[j] = dat[j+2];
				}
				op-=2;
			}
		}
	} while( flg );
#endif
	return( op );						/*	Vf[^Ԃ	*/
}

#ifdef MAIN
extern	int	SetSymData( unsigned char *data );
extern	int	GetSym( unsigned char *sym, unsigned long *code );

int	ReadNextData()
{
	return(-1);
}

int	main( int ar, char *av[] )
{
	int	i, cnt;
	unsigned	char	*ptr[100], pd[100][100];
	char	*dat;
unsigned	long	Code;
char	Sym[1024], Sym2[1024], Data1[512], Data2[512];
int		SymRc;

//	InitHash();			/* nbVe[ȕ */
	pol_init();
	for( i=0; i<100; i++ ) {
		ptr[i] = pd[i];
	}
	if( ar == 2 ) {
		dat = av[1];
	} else {
//		dat = "a*(10+20)*2";
		dat = "(a=5)*3+2";
//		dat = "a*(10 - ++20 )";
	}
	printf( "<<< %s >>>\n", dat );
	SetSymData( dat );
	cnt = 0;
	*Sym = 0;
	while( (SymRc=GetSym( Sym, &Code )) != S_EOF ) {
		ptr[cnt][0] = SymRc;
		strcpy( &ptr[cnt++][1], Sym );
		*Sym = 0;
	}
	printf( "cnt start = %d\n", cnt );
	for( i=0; i<cnt; i++ ) {
		printf( "%s ", ptr[i]+1 );
	}
	cnt = pol( (char **)ptr, cnt );
	printf( "\n\ncnt = %d\n", cnt );
	for( i=0; i<cnt; i++ ) {
		printf( "%s ", ptr[i]+1 );
	}
	printf( "\n" );
//	DestroyHash();		/* nbVe[ůJ */
	return(0);
}
#endif