/* V{o֐ */

#include	<stdio.h>
#include	<string.h>
#include	<ctype.h>
#define	MAIN	0
#include	"sym.h"

static	unsigned	char	line_buff[SYM_LINE_MAX];
static	int	ll = 0, la = 0;
static	FILE	*sym_fp = NULL;
static	unsigned	long	line_number = 0;

#ifdef	SYM_REPLACE
extern	int	devicec_replace( char *sym );
#endif

void	SetLineNumber( unsigned long num )
{
	line_number = num;
}

unsigned	long	GetLineNumber( void )
{
	return( line_number );
}

char	*GetLineBuff( void )
{
	return( (char *)line_buff );
}

void	SetSymFp( FILE *fp )
{
	sym_fp = fp;
	ll = 0;
	la = 0;
}

int	SetSymData( unsigned char *data )
{
	if( strlen( (char *)data ) >= SYM_LINE_MAX-1 ) {
		return(-1);
	}
	strcpy( (char *)line_buff, (char *)data );
	ll = strlen( (char *)data );
	la = 0;
	return(0);
}

int	GetByte( void )
{
	if( ll == la ) {
		if( sym_fp == NULL ) {
			return( S_EOF );
		} else {
			if( fgets( (char *)line_buff, SYM_LINE_MAX, sym_fp ) == NULL ) {
				return( S_EOF );
			}
			ll = strlen( (char *)line_buff );
			la = 0;
			line_number++;
		}
	}
	return( line_buff[la++] );
}

int	esc_code( int *ret )
{
	int		dt;

	if( (dt = GetByte()) == S_EOF ) {
		return( S_ERR );
	}
	switch( dt ) {
	case	'a':	/*	x	*/
		*ret = 0x07;
		break;
	case	'b':	/*	obNXy[X	*/
		*ret = 0x08;
		break;
	case	'f':	/*	tH[tB[h	*/
		*ret = 0x0C;
		break;
	case	'n':
		*ret = 0x0A;
		break;
	case	'r':
		*ret = 0x0D;
		break;
	case	't':
		*ret = 0x09;
		break;
	case	'v':
		*ret = 0x0B;
		break;
	case	'\\':
		*ret = 0x5C;
		break;
	case	'\'':
		*ret = 0x27;
		break;
	case	'\"':
		*ret = 0x22;
		break;
	case	'\?':
		*ret = 0x3F;
		break;
	case	'x':	/* PUiw */
	case	'X':
		if( (dt = GetByte()) == S_EOF ) {
			return( S_ERR );
		}
		if( dt >= '0' && dt <= '9' ) {
			*ret = (dt-'0');
		} else if( toupper(dt) >= 'A' && toupper(dt) <= 'F' ) {
			*ret = toupper(dt)-'A'+10;
		} else {
			return( S_ERR );
		}
		if( (dt = GetByte()) == S_EOF ) {
			return( S_ERR );
		}
		if( dt >= '0' && dt <= '9' ) {
			*ret *= 16;
			*ret += (dt-'0');
		} else if( toupper(dt) >= 'A' && toupper(dt) <= 'F' ) {
			*ret *= 16;
			*ret += toupper(dt)-'A'+10;
		} else {
			la--;
		}
		break;
	default:
		if( dt >= '0' && dt <= '7' ) {
			/* Wiw */
			*ret = (dt-'0');
			if( (dt = GetByte()) == S_EOF ) {
				return( S_ERR );
			}
			if( dt >= '0' && dt <= '7' ) {
				*ret *= 8;
				*ret += (dt-'0');
			} else {
				la--;
				break;
			}
			if( (dt = GetByte()) == S_EOF ) {
				return( S_ERR );
			}
			if( dt >= '0' && dt <= '7' ) {
				*ret *= 8;
				*ret += (dt-'0');
			} else {
				la--;
			}
			break;
		}
		return(S_ERR);
	}
	return(0);
}

int	GetSym( unsigned char *sym, unsigned long *code )
{
	int		rc, dt, n, float_flg;
	static	int	comment_flg = 0;

	if( comment_flg == 1 ) {	/* Rg */
		while( 1 ) {
			if( (dt = GetByte()) == S_EOF ) {
				return( S_EOF );
			}
			if( dt == '\\' ) {
				if( (dt = GetByte()) == S_EOF ) {
					return( S_EOF );
				}
			}
			if( dt == '*' ) {
				if( (dt = GetByte()) == S_EOF ) {
					return( S_EOF );
				}
				if( dt == '/' ) {
					comment_flg = 0;/* RgI */
					break;
				}
			}
		}
	}
	while( 1 ) {
		if( (dt = GetByte()) == S_EOF ) {
			return( S_EOF );
		}
		/*֐AϐAxA\ꓙ*/
		if( isalpha( dt ) || (dt == '#') || (dt == '_') ) {
			n = 0;
			sym[n++] = (unsigned char)dt;
			while( 1 ) {
				if( (dt = GetByte()) == S_EOF ) {
					return( S_EOF );
				}
				if( !isalpha( dt ) && !isdigit( dt ) &&
						(dt != '_' ) && (dt != '.' ) ) {
					la--;				/*	ǂݍ݂PoCg	*/
					sym[n] = 0x00;
					break;
				}
				sym[n++] = (unsigned char)dt;
			}
#ifdef	SYM_REPLACE
			if( (rc = devicec_replace( (char *)sym )) == -1 ) {
				return( S_STR );
			}
			if( rc == M_CHAR || rc == M_INT || rc == M_LONG ) {
				sscanf( (char *)sym, "%ld", code );
			}
			return( rc );
#else
			return( S_STR );			/*	ϐ*/
#endif
		} else if( isdigit( dt ) ) {	/*	l	*/
			n = 0;
			sym[n++] = (unsigned char)dt;
			float_flg = 0;
			while( 1 ) {
				if( (dt = GetByte()) == S_EOF ) {
					break;
				}
				if( n == 1 && sym[0] == '0' && dt == 'x' ) {
					sym[n++] = (unsigned char)dt;
					continue;
				}
				if( dt == '.' ) {
					float_flg++;
					if( float_flg == 2 ) {
						return( S_ERR );
					}
					sym[n++] = (unsigned char)dt;
					continue;
				}
				if( !isxdigit( dt ) ) {
					la--;				/*	ǂݍ݂PoCg	*/
					sym[n] = 0x00;
					break;
				}
				sym[n++] = (unsigned char)dt;
			}
			if( float_flg ) {
				*code = 0;
				return( M_FLOAT );
			}
			if( sym[1] == 'x' ) {
				sscanf( (char *)&sym[2], "%lx", code );
				sprintf( (char *)sym, "%lu", *code );
			} else {
				sscanf( (char *)sym, "%ld", code );
			}
			if( *code < 0x100 ) {
				rc = M_CHAR;
			} else if( *code < 0x10000 ) {
				rc = M_INT;
			} else {
				rc = M_LONG;
			}
			return( rc );
		} else if( isspace( dt ) ) {	/*	؂L	*/
			continue;
		} else if( dt == '"' ) {
			n = 0;
			sym[n++] = (unsigned char)dt;
			while( 1 ) {
				if( (dt = GetByte()) == S_EOF ) {
					return( S_ERR );
				}

				/* 2001/07/01 */
				if( dt >= 0x80 ) {
					/* EUC/SJISR[h1oCgڂƔf */
					sym[n++] = (unsigned char)dt;
					/* 2oCgڂo */
					if( (dt = GetByte()) == S_EOF ) {
						return( S_ERR );
					}
					sym[n++] = (unsigned char)dt;
					continue;
				}

				if( dt == '\\' ) {
					rc = esc_code( &dt );
					if( rc != 0 ) {
						return(rc);
					}
					sym[n++] = (unsigned char)dt;
					continue;
				}
				sym[n++] = (unsigned char)dt;
				if( dt == '"' ) {
					sym[n] = 0x00;
					break;
				}
			}
			return( S_MSG );			/*		*/
		} else if( dt == '\'' ) {
			if( (dt = GetByte()) == S_EOF ) {
				return( S_ERR );
			}
			if( dt == '\\' ) {
				rc = esc_code( &dt );
				if( rc != 0 ) {
					return(rc);
				}
				*code = dt;
			} else {
				*code = dt;
			}
			if( (dt = GetByte()) == S_EOF ) {
				return( S_ERR );
			}
			if( dt != '\'' ) {
				return(S_ERR);
			}
			sprintf( (char *)sym, "%lu", *code );
			return( M_CHAR );
		} else {
			sym[0] = (unsigned char)dt;
			sym[1] = 0x00;
			sym[2] = 0x00;
			sym[3] = 0x00;
			switch( dt ) {
				case	'[':	return( S_LBRCKT );
				case	']':	return( S_RBRCKT );
				case	'(':	return( S_LPAR );
				case	')':	return( S_RPAR );
				case	'{':	return( S_LBRACE );
				case	'}':	return( S_RBRACE );
				case	',':	return( S_COMMA );
				case	';':	return( S_SEMICOL );
				case	':':	return( S_COL );
				case	'~':	return( M_BITREV );
				case	'+':
					if( (dt = GetByte()) == S_EOF ) {
						return( M_PLUS );
					}
					if( dt == '+' ) {
						sym[1] = (unsigned char)dt;
						return( M_INC );
					} else {
						la--;
						return( M_PLUS );
					}
				case	'-':
					if( (dt = GetByte()) == S_EOF ) {
						return( M_MINUS );
					}
					if( dt == '-' ) {
						sym[1] = (unsigned char)dt;
						return( M_DEC );
					} else {
						la--;
						return( M_MINUS );
					}
				case	'*':
					if( (dt = GetByte()) == S_EOF ) {
						return( M_TIMES );
					}
					if( dt == '=' ) {
						sym[1] = (unsigned char)dt;
						return( M_TIMESEQL );
					} else {
						la--;
						return( M_TIMES );
					}
				case	'/':
					if( (dt = GetByte()) == S_EOF ) {
						return( M_SLASH );
					}
					if( dt == '=' ) {
						sym[1] = (unsigned char)dt;
						return( M_SLASHEQL );
					} else if( dt == '*' ) {	/*	Rg	*/
						comment_flg = 1;		/* Rg */
						while( 1 ) {
							if( (dt = GetByte()) == S_EOF ) {
								return( S_ERR );
							}
							if( dt == '\\' ) {
								if( (dt = GetByte()) == S_EOF ) {
									return( S_ERR );
								}
							}
							if( dt == '*' ) {
								if( (dt = GetByte()) == S_EOF ) {
									return( S_ERR );
								}
								if( dt == '/' ) {
									comment_flg = 0;/* RgI */
									break;
								}
							}
						}
						break;
					} else if( dt == '/' ) {	/*	s܂ŃRg	*/
						ll = la = 0;
						break;
					} else {
						la--;
						return( M_SLASH );
					}
				case	'=':
					if( (dt = GetByte()) == S_EOF ) {
						return( M_EQL );
					}
					if( dt == '=' ) {
						sym[1] = (unsigned char)dt;
						return( M_CMP );
					} else {
						la--;
						return( M_EQL );
					}
				case	'%':
					if( (dt = GetByte()) == S_EOF ) {
						return( M_MOD );
					}
					if( dt == '=' ) {
						sym[1] = (unsigned char)dt;
						return( M_MODEQL );
					} else {
						la--;
						return( M_MOD );
					}
				case	'!':
					if( (dt = GetByte()) == S_EOF ) {
						return( M_NOT );
					}
					if( dt == '=' ) {
						sym[1] = (unsigned char)dt;
						return( M_NEQ );
					} else {
						la--;
						return( M_NOT );
					}
				case	'<':
					if( (dt = GetByte()) == S_EOF ) {
						return( M_LSS );
					}
					if( dt == '=' ) {
						sym[1] = (unsigned char)dt;
						return( M_LEQ );
					} else if( dt == '<' ) {
						sym[1] = (unsigned char)dt;
						if( (dt = GetByte()) == S_EOF ) {
							return( M_SHIFTL );
						}
						if( dt == '=' ) {
							sym[2] = (unsigned char)dt;
							return( M_ASSLEQL );
						} else {
							la--;
							return( M_SHIFTL );
						}
					} else {
						la--;
						return( M_LSS );
					}
				case	'>':
					if( (dt = GetByte()) == S_EOF ) {
						return( M_GTR );
					}
					if( dt == '=' ) {
						sym[1] = (unsigned char)dt;
						return( M_GEQ );
					} else if( dt == '>' ) {
						sym[1] = (unsigned char)dt;
						if( (dt = GetByte()) == S_EOF ) {
							return( M_SHIFTR );
						}
						if( dt == '=' ) {
							sym[2] = (unsigned char)dt;
							return( M_ASSREQL );
						} else {
							la--;
							return( M_SHIFTR );
						}
					} else {
						la--;
						return( M_GTR );
					}
				case	'&':
					if( (dt = GetByte()) == S_EOF ) {
						return( M_BITAND );
					}
					if( dt == '=' ) {
						sym[1] = (unsigned char)dt;
						return( M_ANDEQL );
					} else if( dt == '&' ) {
						sym[1] = (unsigned char)dt;
						return( M_AND );
					} else {
						la--;
						return( M_BITAND );
					}
				case	'|':
					if( (dt = GetByte()) == S_EOF ) {
						return( M_BITOR );
					}
					if( dt == '=' ) {
						sym[1] = (unsigned char)dt;
						return( M_OREQL );
					} else if( dt == '|' ) {
						sym[1] = (unsigned char)dt;
						return( M_OR );
					} else {
						la--;
						return( M_BITOR );
					}
				case	'^':
					if( (dt = GetByte()) == S_EOF ) {
						return( M_BITXOR );
					}
					if( dt == '=' ) {
						sym[1] = (unsigned char)dt;
						return( M_XOREQL );
					} else {
						la--;
						return( M_BITXOR );
					}
				default:
					if( dt == 0x1a ) {
						return( S_EOF );
					}
					return(S_ERR);
			}
		}
	}
}
