#include	<windows.h>
#include	"comm.h"


OVERLAPPED	FReadOv, FWriteOv;

int	OpenRs232c(char *PortStr)
{
	HANDLE	cid;
	DCB		dcb;
	DWORD	DErr;
	COMMTIMEOUTS	CommTimeouts;
	char	P[50];


	strcpy(P,"COM");
	strcpy(P,"\\\\.\\");
	strcat(P,PortStr);

	cid = CreateFile(P,GENERIC_READ | GENERIC_WRITE,
		   0,NULL,OPEN_EXISTING,
		   FILE_FLAG_OVERLAPPED,NULL);
	if( cid < 0 ) {
		return(-1);
	}

	FReadOv.Offset = 0;
	FReadOv.OffsetHigh = 0;
	FWriteOv.hEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
	FWriteOv.Offset = 0;
	FWriteOv.OffsetHigh = 0;
	FWriteOv.hEvent = CreateEvent(NULL,TRUE,FALSE,NULL);

	ClearCommError(cid,&DErr,NULL);
	SetupComm(cid,4096,4096);	/* obt@TCY */

	FlushRs232c((int)cid);	/* RS232C |[g̋ */

	memset(&CommTimeouts,0,sizeof(CommTimeouts));
	CommTimeouts.ReadIntervalTimeout = 0xFFFFFFFF;
	CommTimeouts.ReadTotalTimeoutMultiplier = 0;
	CommTimeouts.ReadTotalTimeoutConstant = 0;
//	CommTimeouts.ReadTotalTimeoutConstant = 100;
	CommTimeouts.WriteTotalTimeoutMultiplier = 0;
	CommTimeouts.WriteTotalTimeoutConstant = 1000;
	SetCommTimeouts(cid,&CommTimeouts);

	memset(&dcb,0,sizeof(DCB));
	dcb.DCBlength = sizeof(DCB);
	dcb.BaudRate = 38400;
	dcb.fBinary = TRUE;
	dcb.Parity = NOPARITY;

	dcb.fDtrControl = DTR_CONTROL_ENABLE;
	dcb.fRtsControl = RTS_CONTROL_ENABLE;
	dcb.fOutxCtsFlow = TRUE;
	dcb.fRtsControl = RTS_CONTROL_HANDSHAKE;
	dcb.ByteSize = 8;
	dcb.StopBits = ONESTOPBIT;
	SetCommState(cid, &dcb);

	SetCommMask(cid,0);
	SetCommMask(cid,EV_RXCHAR);

	return( (int)cid );
}

int	CloseRs232c(int PortCid)	/* RS232C |[g̃N[Y */
{
	int	rc;

	rc = (int)(CloseHandle((HANDLE)PortCid));
	CloseHandle(FReadOv.hEvent);
	CloseHandle(FWriteOv.hEvent);
    return(rc);
}

int	WriteRs232c(int PortCid, char *Data, int Len)	/* RS232C |[gւ̏ */
{
	DWORD	dwLength;

	return((int)(WriteFile((HANDLE)PortCid,Data,Len,&dwLength,&FWriteOv)));
}

int	ReadRs232c(int PortCid, char *Data, int Len)	/* RS232C |[gǂ݂ */
{
	DWORD	dwLength;
	if( ReadFile((HANDLE)PortCid,Data,Len,&dwLength,&FReadOv) ) {
		return(int(dwLength));
	}
	return(0);
}

int	FlushRs232c(int PortCid)	/* RS232C |[g̋ */
{
	PurgeComm((HANDLE)PortCid,PURGE_TXABORT |
					  PURGE_RXABORT |
					  PURGE_TXCLEAR |
					  PURGE_RXCLEAR);
	return(0);
}
